# coding: utf-8

"""
    Pulp 3 API

    Fetch, Upload, Organize, and Distribute Software Packages  # noqa: E501

    The version of the OpenAPI document: v3
    Contact: pulp-list@redhat.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from pulpcore.client.pulpcore.configuration import Configuration


class PatchedAccessPolicy(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'permissions_assignment': 'list[object]',
        'statements': 'list[object]',
        'viewset_name': 'str'
    }

    attribute_map = {
        'permissions_assignment': 'permissions_assignment',
        'statements': 'statements',
        'viewset_name': 'viewset_name'
    }

    def __init__(self, permissions_assignment=None, statements=None, viewset_name=None, local_vars_configuration=None):  # noqa: E501
        """PatchedAccessPolicy - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._permissions_assignment = None
        self._statements = None
        self._viewset_name = None
        self.discriminator = None

        if permissions_assignment is not None:
            self.permissions_assignment = permissions_assignment
        if statements is not None:
            self.statements = statements
        if viewset_name is not None:
            self.viewset_name = viewset_name

    @property
    def permissions_assignment(self):
        """Gets the permissions_assignment of this PatchedAccessPolicy.  # noqa: E501

        List of callables that define the new permissions to be created for new objects.  # noqa: E501

        :return: The permissions_assignment of this PatchedAccessPolicy.  # noqa: E501
        :rtype: list[object]
        """
        return self._permissions_assignment

    @permissions_assignment.setter
    def permissions_assignment(self, permissions_assignment):
        """Sets the permissions_assignment of this PatchedAccessPolicy.

        List of callables that define the new permissions to be created for new objects.  # noqa: E501

        :param permissions_assignment: The permissions_assignment of this PatchedAccessPolicy.  # noqa: E501
        :type: list[object]
        """

        self._permissions_assignment = permissions_assignment

    @property
    def statements(self):
        """Gets the statements of this PatchedAccessPolicy.  # noqa: E501

        List of policy statements defining the policy.  # noqa: E501

        :return: The statements of this PatchedAccessPolicy.  # noqa: E501
        :rtype: list[object]
        """
        return self._statements

    @statements.setter
    def statements(self, statements):
        """Sets the statements of this PatchedAccessPolicy.

        List of policy statements defining the policy.  # noqa: E501

        :param statements: The statements of this PatchedAccessPolicy.  # noqa: E501
        :type: list[object]
        """

        self._statements = statements

    @property
    def viewset_name(self):
        """Gets the viewset_name of this PatchedAccessPolicy.  # noqa: E501

        The name of ViewSet this AccessPolicy authorizes.  # noqa: E501

        :return: The viewset_name of this PatchedAccessPolicy.  # noqa: E501
        :rtype: str
        """
        return self._viewset_name

    @viewset_name.setter
    def viewset_name(self, viewset_name):
        """Sets the viewset_name of this PatchedAccessPolicy.

        The name of ViewSet this AccessPolicy authorizes.  # noqa: E501

        :param viewset_name: The viewset_name of this PatchedAccessPolicy.  # noqa: E501
        :type: str
        """

        self._viewset_name = viewset_name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PatchedAccessPolicy):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PatchedAccessPolicy):
            return True

        return self.to_dict() != other.to_dict()
